#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>

int main (int argc, char* argv[])
{
  IplImage* img = NULL;

  /* Vérification: au moins un argument doit être passé au programme.*/
  if (argc < 2)
  {
    fprintf (stderr, "usage: %s IMAGE\n", argv[0]);
    return EXIT_FAILURE;
  }

  /* Chargement de l'image passée en argument */
  img = cvLoadImage(argv[1], CV_LOAD_IMAGE_GRAYSCALE);

  if (!img)
  {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
  }

  int y=10;
  int x=0;
  int xMax=img-> width; //largeur de l'image
  int yMax=img-> height; //hauteur de l'image
  uchar varpixel=0; //variable = couleur pixel
  uchar *pixel=&varpixel; //pointeur sur varpixel
  int tab[yMax][3];
  int blancAv=0;
  int blanc=0;

//detection 1ere ligne
  y=0; //on se place sur la 1ere ligne

  for (x=0; x<xMax; x++) //on avance colonne par colonne depuis la gauche
    {
        pixel = cvPtr2D (img, y, x, NULL); //on mesure la couleur de chaque pixel
        if (*pixel > 100) //1er pixel blanc trouvé
        {
            tab[y][0]=x; //on sauvegarde le pixel
            printf ("y: %d",y);
            printf("  xGauche: %d ",tab[y][0]);
            printf ("valeur pixel %u  ",*pixel);
            x=xMax; //on sort de la boucle for
        }
    }//trouve le premier pixel blanc de la première ligne depuis la gauche

    for (x=xMax-1; x>0; x--)
    {
        pixel = cvPtr2D (img, y, x, NULL);
        if (*pixel > 100)
        {
            tab[y][1]=x;
            printf ("y: %d  ",y);
            printf("xDroite: %d  ",tab[y][1]);
            printf ("valeur pixel %u  ",*pixel);
            x=0;
        }
    }//trouve le premier pixel blanc de la première ligne depuis la droite
//fin detection  1ere ligne

//calcul xmoyen
tab[y][2] = tab[y][0] + tab[y][1];
tab[y][2] = tab[y][2] / 2; //on sauvegarde xMoyen dans la troisième colone du tableau
printf("moyenne: %d  \n",tab[y][2]);

//on passe à la 1ere ligne
y=1;

//detection toutes les lignes suivantes

for (y=1; y<yMax; y=y+100)//on parcourt toutes les lignes
{

    for (x=tab[0][2]; x<xMax; x++)//à partir de xMoyen ligne0 on avance vers la droite
    {
        pixel = cvPtr2D (img, y, x-1, NULL);
        blancAv = (*pixel>100) ? 1:0 ;
        pixel = cvPtr2D (img, y, x, NULL); //on mesure chaque pixel
        blanc = (*pixel>100) ? 1:0 ;
        if (blancAv && !blanc) //si pixel noir et pixel précèdent blanc
        {
            tab[y][0]=x-1;//le pixel precedent etait blanc, on saugarde sa coordonnée dans le tableau
            x=xMax;//on sort de la boucle for, on peut passer à la ligne suivante
        }
    }

   for (x=tab[0][2]; x>0; x--)//idem vers la gauche
    {
        pixel = cvPtr2D (img, y, x+1, NULL);
        blancAv = (*pixel>100) ? 1:0 ;
        pixel = cvPtr2D (img, y, x, NULL); //on mesure chaque pixel
        blanc = (*pixel>100) ? 1:0 ;
        if (blancAv && !blanc) //si pixel noir et pixel précèdent blanc
        {
            tab[y][1]=x+1;
            x=0;
        }
    }

//calcul de tous les xmoyen
    tab[y][2] = tab[y][0] + tab[y][1];
    tab[y][2] = tab[y][2] / 2;
//affichage des données
    printf( "y: %d  ",y);
    printf( "xGauche: %d  ",tab[y][0]);
    printf( "xDroite: %d  ",tab[y][1]);
    printf("moyenne: %d\n",tab[y][2]);

}

//FIN

  /* Libération de la mémoire */
  cvReleaseImage (&img);

  return EXIT_SUCCESS;
}
