#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>

int main (int argc, char* argv[])
{
  IplImage* img = NULL;

  /* Vérification: au moins un argument doit être passé au programme.*/
  if (argc < 2)
  {
    fprintf (stderr, "usage: %s IMAGE\n", argv[0]);
    return EXIT_FAILURE;
  }

  /* Chargement de l'image passée en argument */
  img = cvLoadImage(argv[1], CV_LOAD_IMAGE_GRAYSCALE);

  if (!img)
  {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
  }

  int y=0;
  int x=0;
  int xMax=img-> width; //largeur de l'image
  int yMax=img-> height; //hauteur de l'image
  uchar varpixel=0; //variable = couleur pixel
  uchar *pixel=&varpixel; //pointeur sur varpixel
  int tab[yMax][3]; //tableau xgauche xdroite xmoyen

//detection toutes les lignes suivantes

for (y=0; y<yMax; y++)//on parcourt toutes les lignes
{
  for (x=0; x<xMax; x++) //on avance colonne par colonne depuis la gauche
    {
        pixel = cvPtr2D (img, y, x, NULL); //on mesure la couleur de chaque pixel
        if (*pixel > 100) //1er pixel blanc trouvé
        {
            tab[y][0]=x; //on sauvegarde le pixel
            x=xMax; //on sort de la boucle for
        }
        else if (*pixel < 100 && x==xMax-1)//si uniquement pixel noir jusqu'au bout
        {
            tab[y][0]=0;//on met 0 pour cette ligne
            x=xMax;//on sort de la boucle for
        }
    }//trouve le premier pixel blanc de chaque ligne depuis la gauche

    for (x=xMax-1; x>0; x--)
    {
        pixel = cvPtr2D (img, y, x, NULL);
        if (*pixel > 100)
        {
            tab[y][1]=x;
            x=0;
        }
          else if (*pixel < 100 && x==1)
        {
            tab[y][1]=0;
            x=0;
        }
    }//trouve le premier pixel blanc de chaque ligne depuis la droite

//calcul de tous les xmoyen
    tab[y][2] = tab[y][0] + tab[y][1];
    tab[y][2] = tab[y][2] / 2;
//affichage des données
    printf( "y: %d  ",y);
    printf( "xGauche: %d  ",tab[y][0]);
    printf( "xDroite: %d  ",tab[y][1]);
    printf("moyenne: %d\n",tab[y][2]);
}

  /* Libération de la mémoire */
  cvReleaseImage (&img);

  return EXIT_SUCCESS;
}
