#include <cv.h>
#include <highgui.h>
#include <iostream>

using namespace cv;

double alpha; /**< Simple contrast control */
int beta;  /**< Simple brightness control */

int main( int argc, char** argv )
{
/// Read image given by user
Mat image = imread( argv[1] );
Mat new_image = Mat::zeros( image.size(), image.type() );

/// Initialize values
std::cout<<" Basic Linear Transforms "<<std::endl;
std::cout<<"-------------------------"<<std::endl;
std::cout<<"* Enter the alpha value [1.0-3.0]: ";std::cin>>alpha; //1.5
std::cout<<"* Enter the beta value [0-100]: "; std::cin>>beta;  //-100


/// Do the operation new_image(i,j) = alpha*image(i,j) + beta
for( int y = 0; y < image.rows; y++ )
{
    for( int x = 0; x < image.cols; x++ )
    {
            new_image.at<Vec3b>(y,x)[0] = 0; //canal bleu et vert à 0
            new_image.at<Vec3b>(y,x)[1] = 0;
            new_image.at<Vec3b>(y,x)[2] = saturate_cast<uchar>( alpha*( image.at<Vec3b>(y,x)[2] )+beta);//saturation canal rouge
    }
}

imwrite(argv[2],new_image);

return 0;
}
