#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>
#include <opencv/cv.h>


int main (int argc, char* argv[])
{
  IplImage* image = NULL;

  /* Vérification: au moins 2 arguments doivent être passés au programme.*/
  if (argc < 3)
  {
    fprintf (stderr, "usage: %s entrer une IMAGE en paramètre \n", argv[0]);
    return EXIT_FAILURE;
  }

  /* Chargement de l'image passée en argument 1*/
  image = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);

  if (!image)
  {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
  }

IplConvKernel *kernel;
kernel = cvCreateStructuringElementEx(20, 20, 2, 2, CV_SHAPE_ELLIPSE, NULL); //creation zone d'interet
cvDilate(image, image, kernel, 1);					     //dilatation
kernel = cvCreateStructuringElementEx(25, 25, 2, 2, CV_SHAPE_ELLIPSE, NULL); //creation zone d'interet2
cvErode(image, image, kernel, 1);					     //erosion

//sauvegarder
  cvSaveImage(argv[2], image, 0);

  /* Libération de la mémoire */
  cvReleaseImage (&image);

  return EXIT_SUCCESS;
}
