#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>
#include <opencv/cv.h>



int main (int argc, char* argv[])
{
    IplImage* bigimage = NULL;

    /* Vérification: au moins 2 arguments doivent être passés au programme.*/
    if (argc < 3)
    {
    fprintf (stderr, "usage: %s entrer une IMAGE en paramètre \n", argv[0]);
    return EXIT_FAILURE;
    }


    /* Chargement de l'image passée en argument */
    bigimage = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);

    if (!bigimage)
    {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
    }

    int bigXmax=bigimage-> width; //longeur de l'image à redim
    int bigYmax=bigimage-> height; //largeur de l'image à redim
    int xdroite=100, xgauche=400 ,yhaut=100 ,ybas=400; //redim de chaques cotés

    //dimensions du ROI
    int smallXmin=xgauche, smallXlong=bigXmax-(smallXmin+xdroite), smallYmin=yhaut, smallYlong=bigYmax-(yhaut+ybas);

    //création du ROI
    cvSetImageROI(bigimage,cvRect( smallXmin, smallYmin, smallXlong, smallYlong));

    //création nouvelle image
    IplImage *smallimage = cvCreateImage(cvGetSize(bigimage), 8, 3);

    //copie de la grande(uniquement le ROI) dans la petite
    cvCopy(bigimage, smallimage, NULL);

    //sauvegarde
    cvSaveImage(argv[2], smallimage, 0);


    /* Libération de la mémoire */
    cvResetImageROI(bigimage);
    cvReleaseImage (&bigimage);
    cvReleaseImage(&smallimage);


    return EXIT_SUCCESS;
}

